#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include "usbdrv.h"
#include <stdlib.h>
#include <string.h>
#include "integer.h"
#include "diskio.h"
#include "tff.h"
#define	MMC_WAIT	50	
#define MMC_CS_PORT     PORTB
#define MMC_CS_DDR      DDRB
#define MMC_CS_ON       MMC_CS_PORT &= ~(1<<MMC_CS)
#define MMC_CS_OFF      MMC_CS_PORT |= (1<<MMC_CS) 
#define MMC_CS          2
#define MMC_MOSI        3 
#define MMC_SCK         5  
#define WDR             asm volatile("wdr\n"::)  
#define SLEEP   asm volatile("sleep\n"::)

volatile uchar  MMCtimer;    
void      SPI_out(uchar data);  
uchar     SPI_in(void);  

typedef	unsigned int	uint;
typedef	unsigned long	ulong;
typedef unsigned short	ushort;

uchar usbFunctionSetup(uchar data[8])
{
static uchar replybuf[8];
    usbMsgPtr = replybuf;
FATFS fs;
FIL fsrc,fdst;
BYTE buffer[100];
FRESULT res;
UINT br,bw;
if(data[1]==0){
	f_mount(0,&fs);
	res = f_open(&fsrc, "test.txt", FA_OPEN_EXISTING | FA_READ);
	replybuf[0]=res;
	return 1;}
if(data[1]==1){
	res = f_open(&fdst, "test2.txt", FA_CREATE_ALWAYS | FA_WRITE);
	replybuf[0]=res;
	return 1;}
if(data[1]==2){
	res = f_read(&fsrc, buffer, sizeof(buffer), &br);
	replybuf[0]=res;
        res = f_write(&fdst, buffer, br, &bw);
	replybuf[1]=res;
	return 2;}
if(data[1]==3){
	f_close(&fsrc);
	f_close(&fdst);
	f_mount(0,NULL);
	return 0;}

return 0;
} 

int main(void)
{ 
PORTB = (1<<MMC_CS)|(1<<MMC_MOSI)|(1<<MMC_SCK);
DDRB = (1<<MMC_CS)|(1<<MMC_MOSI)|(1<<MMC_SCK);
SPCR=(1<<SPE)|(1<<MSTR);

  usbInit();
  sei();
  for(;;){	        /* main event loop */
    	usbPoll();
	  }
  return 0;
}

//****************************************
//	MMC/SD SPIR}ho
//****************************************
uchar SPI_command(uchar com, ulong arg){
	uint	i;
	uchar	r = 0;

	// BUSY`FbN
	MMCtimer = MMC_WAIT;	// ԑ҂
	while(MMCtimer){
		r = SPI_in();
		if (r == 0xFF)	break;
	}
	if (r != 0xFF)	return 1;

	SPI_out(com|0x40);
	SPI_out(arg >> 24);
	SPI_out(arg >> 16);
	SPI_out(arg >> 8);
	SPI_out(arg);
	SPI_out(0x95);	// R}hCRC

	// R1҂
	for (i = 0; i < 5000; i++){
		r = SPI_in();
		if (r != 0xFF)	break;
	}

	return r;
}


//****************************************
//	SPIf[^o
//****************************************
void SPI_out(uchar data){

	SPDR = data;
	while(!(SPSR & (1<<SPIF)));
}


//****************************************
//	SPIf[^
//****************************************
uchar SPI_in(void){

	SPDR = 0xFF;
	while(!(SPSR & (1<<SPIF)));
	return SPDR;
}



//*****************************************************************
//	Low Level routine for Tiny-FatFs
//*****************************************************************

static volatile
DSTATUS Stat[1] = {STA_NOINIT};	/* Disk status */

//****************************************
// fBXN
//****************************************
DSTATUS disk_initialize(BYTE drive){
	uchar	c;

	if (drive)	return STA_NOINIT;
	
	// J[h̗L͒ڂ킩Ȃ

	if (!(Stat[drive] & STA_NODISK)){

		Stat[drive] = STA_NOINIT;
	
		// SPI}X^, CPOL=1, CPHA=1, Clock 8MHz/64=125kHz
		SPCR = (1<<SPE)|(1<<MSTR)|(1<<CPOL)|(1<<CPHA)|(1<<SPR1);

		// CS = H
		MMC_CS_OFF;

		// MMC/SD SPI[hڍsÕNbNM
		for (c = 0; c < 20; c++){
			SPI_in();
		}

		// SPI[hڍsR}h
		WDR;
		MMC_CS_ON;		// CS=L
		c = SPI_command(0, 0);
		while ((c != 1)&&(c != 0xFF)){
			c = SPI_command(0, 0);
			SLEEP;
		}
		while (c == 1){
			c = SPI_command(1, 0);
			SLEEP;
		}
		MMC_CS_OFF;		// CS=H
		SPI_in();

		// SPI Clock 8MHz/4=2MHz
		SPCR &= ~(1<<SPR1);
		SPSR |= (1<<SPI2X);	// SPINbN 4MHz

		if (c != 0){
			Stat[drive] = STA_NODISK|STA_NOINIT;
			return Stat[drive];
		}

		Stat[drive] &= ~STA_NOINIT;

		// CgveNgo

	}
	return Stat[drive];	
}


//****************************************
// fBXNԎ擾
//****************************************
DSTATUS disk_status(BYTE drive){

	if (drive)	return STA_NOINIT;

	// J[h̗L͂킩Ȃ
	// CgveNg킩Ȃ
	
	return Stat[drive];	
}


//****************************************
// fBXNǂݍ
//****************************************
DRESULT disk_read(BYTE drive, BYTE *buffer, DWORD sectorNumber, BYTE sectorCount){
	uint	i;
	uchar	r;

	if (drive || !sectorCount) return RES_PARERR;
	if (Stat[drive] & STA_NOINIT)	return RES_NOTRDY;

	if (disk_status(drive) & (STA_NODISK|STA_NOINIT))	return RES_NOTRDY;

	sectorNumber *= 512;
	
	WDR;
	while(sectorCount > 0){

		MMC_CS_ON;	// CS=L
		SPI_in();

		r = SPI_command(17, sectorNumber);
		if (r == 0){
			MMCtimer = MMC_WAIT;	// ԑ҂
			while(MMCtimer){
				r = SPI_in();
				if (r == 0xFE){
					break;		// ]Jn}[N
				}
			}
		}

		if (r != 0xFE){
			r = 1;
			goto QUIT;		// ERROR
		} else {
			r = 0;
		}

		for (i = 0; i < 512; i++){
			*buffer++ = SPI_in();
		}

		SPI_in();	// CRC
		SPI_in();	// CRC

	  QUIT:
		MMC_CS_OFF;	// CS=H
		SPI_in();

		if (r)	return RES_ERROR;
		
		sectorNumber += 512;
		--sectorCount;
	}

	return RES_OK;
}


//****************************************
// fBXN
//****************************************
DRESULT disk_write(BYTE drive, const BYTE *buffer, DWORD sectorNumber, BYTE sectorCount){

#if _FS_READONLY == 0

	uint	i;
	uchar	r = 0;

	if (drive || !sectorCount) return RES_PARERR;
	if (Stat[drive] & STA_NOINIT) return RES_NOTRDY;
	if (Stat[drive] & STA_PROTECT) return RES_WRPRT;

	WDR;
	while(sectorCount > 0){
		MMC_CS_ON;	// CS=L
		SPI_in();

		// BUSY`FbN
		MMCtimer = MMC_WAIT;
		while(MMCtimer){
			r = SPI_in();
			if (r == 0xFF)	break;
		}
		if (r != 0xFF){
			r = 1;
			goto QUIT;
		}

		r = 1;
		if (SPI_command(24, sectorNumber << 9) == 0){	// ݃R}h
			SPI_out(0xFE);	// X^[gubN
			for (i = 0; i < 512; i++){
				SPI_out(*buffer++);
			}
			SPI_in();	// CRCAĂ
			SPI_in();

			// X|XM
			for (i = 0; i < 3000; i++){
				r = SPI_in() & 0x1F;
				if ((r & 0x11) == 0x01)	break;
			}

			if (r == 0x05){
				r = 0;	// ɏ߂͂
			} else {
				r = 1;	// ݃G[
			}
		}
	  QUIT:	
		MMC_CS_OFF;	// CS=H
		SPI_in();

		if (r)	return RES_ERROR;

		sectorNumber++;
		--sectorCount;
	}

#endif
	return RES_OK;
}


//****************************************
// fBXN ioctl
//****************************************
DRESULT disk_ioctl(BYTE drive, BYTE command, void *buffer){
	uchar	r;
	BYTE csd[16];
	WORD csm, csize;
	uint i;

	WDR;
	if (disk_status(drive) & STA_NOINIT) return RES_NOTRDY;

	switch(command){
	  case GET_SECTOR_COUNT:

		MMC_CS_ON;	// CS=L
		r = SPI_command(9, 0);
		if (r == 0){
			for (i = 0; i < 1000; i++){	// ҂
				r = SPI_in();
				if (r == 0xFE){
					break;		// ]Jn}[N
				}
			}
		}

		if (r != 0xFE){
			r = RES_ERROR;
			goto QUIT;		// ERROR
		}

		for (i = 0; i < 16; i++){
			csd[i] = SPI_in();
		}

		SPI_in();	// CRC
		SPI_in();	// CRC

		csm = ((csd[10] & 128) >> 7) + ((csd[9] & 3) << 1) + 2;
		csize = ((csd[8] & 0xC0) >> 6) + ((WORD)csd[7] << 2) + ((WORD)(csd[6] & 3) << 10) + 1;
		*(DWORD*)buffer = (DWORD)csize << csm;
		r = RES_OK;
	  QUIT:
		MMC_CS_OFF;	// CS=H
		SPI_in();
		return r;

	  case CTRL_SYNC:
		MMC_CS_ON;	// CS=L
		SPI_in();
		MMCtimer = MMC_WAIT;
		r = RES_ERROR;
		while(MMCtimer){
			if (SPI_in() == 0xFF){
				r = RES_OK;
				break;
			}
		}
		MMC_CS_OFF;	// CS=H
		SPI_in();
		return r;

	  default:
		return RES_PARERR;
	}
}


//****************************************
// ^CX^v擾
//****************************************
DWORD get_fattime(void){

	return 0;	// RTĈ
}

