/* DA convertor using MAX517 via USB using tiny45
designed by takefuji on jan.3, 2008 */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include "usbdrv.h"

void delay(unsigned int p)
{
  unsigned char i;        
  unsigned char j;	 //one loop is 3.8us with 12MHz
  for(i=0;i<p;i++)
    for(j=0;j<10;j++);
}

void pulse(unsigned char data)
{
if((data & 0x01)==0){PORTB = 0x00; }	//SDA=0
 else {PORTB = 0x02;  }			//SDA=1
delay(1); 
PORTB = PORTB | 0x10;			//SCL=1
delay(1);
PORTB = PORTB & 0x02; 			//SCL=0
delay(1);
}

void start_strm()
{
 PORTB = 0x10; //SDA=0
 delay(1);
 PORTB= 0x00;
 delay(1);
}


void stop_strm()
{
 PORTB = 0x10;  //SCL=1
 delay(1);
 PORTB = 0x12;  //SDA=1
 delay(1);
}

void ack_strm()
{
PORTB = 0x00;  //SDA=0
 delay(1);
PORTB = 0x10;   //SCL=1
 delay(1);
PORTB = 0x00;   //SCL=0
 delay(1);
}

/*-------------generate pulse stream---------------*/
//SCL=PB4, SDA=PB1
void pulse_strm(unsigned char sda)
{
  unsigned char i,ret;

   for(i=0;i<8;i++){ret=(sda>>(7-i)); pulse(ret); }     
}   


uchar usbFunctionSetup(uchar data[3])
{

    if(data[1] == 0){
	start_strm();
	pulse_strm(0x5E);	//01011110 AD1=AD0=1
	ack_strm();
	pulse_strm(0x00);	//00000000 RST=PD=A0=0
	ack_strm();
        pulse_strm(data[2]);	// data[2] is for voltage
	ack_strm();
	stop_strm(); }
	return 0;
}

int main(void)
{ 
  DDRB = 0x12;	// 0001 0010 PB1=SDA and PB4=SCL are output
  PORTB = 0x12;	//SDA=SCL=1

  usbInit();
  sei();
  for(;;){		// main event loop
    	usbPoll();
	  }
  return 0;
}
