/* programmable pulse generator using DS1803 and LTC1799 with tiny85 via USB
designed by takefuji on May 13, 2007 */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include "usbdrv.h"

void delay(unsigned int p)
{
  unsigned char i;        
  unsigned char j;	 //one loop is 3.8us with 12MHz
  for(i=0;i<p;i++)
    for(j=0;j<10;j++);
}

void pulse(unsigned char data)
{
if((data & 0x01)==0){PORTB = 0x00; }	//SDA=0
 else {PORTB = 0x02;  }			//SDA=1
delay(20); 
PORTB = PORTB | 0x20;			//SCL=1
delay(20);
PORTB = PORTB & 0x02; 			//SCL=0
delay(20);
}

void start_strm()
{delay(20);
 PORTB = 0x20; //SDA=0
 delay(20);
 PORTB= 0x00;
 delay(20);
}


void stop_strm()
{delay(20);
 PORTB = 0x20;  //SCL=1
 delay(20);
 PORTB = 0x22;  //SDA=1
 delay(20);
}

void ack_strm()
{
DDRB=0x20;
 
delay(2);
PORTB = 0x20;   //SCL=1
 delay(5);
PORTB = 0x00;   //SCL=0
 delay(2); 
DDRB=0x22;
}

/*-------------generate pulse stream---------------*/
//SCL=PB5, SDA=PB1
void pulse_strm(unsigned char sda)
{
  unsigned char i,ret;

   for(i=0;i<8;i++){ret=(sda>>(7-i)); pulse(ret); }     
}   


uchar usbFunctionSetup(uchar data[8])
{
static uchar replybuf[4];	
uchar pot0,pot1;	
usbMsgPtr = replybuf;
pot0=data[2];
pot1=data[4];

if(data[1]==0){
	start_strm();		//start
	pulse_strm(0x50);	//control:01010000 A2=A1=A0=0
	ack_strm();		//ack
	pulse_strm(0xa9);	//command:10101001 
	ack_strm();		//ack
        pulse_strm(pot0);	// pot-0 data
	ack_strm();		//ack
	stop_strm(); 		//stop
	start_strm();		//start
	pulse_strm(0x50);	//control:01010000 A2=A1=A0=0
	ack_strm();		//ack
	pulse_strm(0xaa);	//command:10101010 
	ack_strm();		//ack
        pulse_strm(pot1);	// pot-0 data
	ack_strm();		//ack
	stop_strm(); 		//stop
	replybuf[0]=pot0;
	replybuf[1]=pot1;
	
	return 2;}
return 0;
  	
}

int main(void)
{ 
  DDRB = 0x22;	// 0010 0010 PB1=SDA and PB5=SCL are output
  PORTB = 0x22;	//SDA=SCL=1
  delay(20);
  usbInit();
  sei();
  for(;;){		// main event loop
    	usbPoll();
	  }
  return 0;
}
