/* programmable pulse generator using DS1803 and LTC1799 with tiny85 via USB
designed by takefuji
*/
#include <usb.h>
#include <stdio.h>
#include <string.h>
unsigned short IDVendor=   0x1384;		/*VID must be changed. */
unsigned short IDProduct=  0x8888;		/*PID must be changed. */

static int usbOpenDevice(usb_dev_handle **device, int idvendor, int idproduct)
{
	struct usb_bus *bus;
	struct usb_device *dev;
	usb_dev_handle *udh=NULL;
	int retp, retm,errors;
	char string[256];
	usb_init();
	retp=usb_find_busses();
	retm=usb_find_devices(); if(retp!=retm){return errors=1;}
	for (bus = usb_busses; bus; bus = bus->next)
	{
		for (dev = bus->devices; dev; dev = dev->next)
		{
			udh=usb_open(dev);
			retp = usb_get_string_simple(udh, dev->descriptor.iProduct, string, sizeof(string));
			retm=usb_get_string_simple(udh, dev->descriptor.iManufacturer, string, sizeof(string));
			if (retp > 0 && retm > 0)
				if (idvendor==dev->descriptor.idVendor && idproduct==dev->descriptor.idProduct){ *device=udh;return errors=0;}
		}
	}
				 usb_close(udh);return errors=1;
}


int main(int argc, char **argv)
{
	usb_dev_handle *d=NULL;
	unsigned char buffer[8];
	int i, mode, ret,k;
	char string[256];

	if(argc <2)
	{
		printf("give the frequency(500KHz-20000KHz).\n");
		exit(1);
	}
	k=floor((512.0/200.0)*((100000.0/atof(argv[1]))-3.3)) ;
 if(k>511 || k<2){printf("frequency must be between 500KHz and 20MHz \n"); exit(1);} 
     if(k<256){mode=k;i=0;}
	else {mode=255;i=k-255;} 
printf("k= %d\n",k);
usb_init();
ret=usbOpenDevice(&d, IDVendor,IDProduct);
while(ret!=0){;}
if(ret!=0){printf("usbOpenDevice failed\n"); return 0;}

	ret=usb_control_msg(d, USB_TYPE_VENDOR | USB_RECIP_DEVICE | USB_ENDPOINT_IN, 0, mode, i, (char *)buffer, sizeof(buffer), 5000);
//for(k=0;k<2;k++){printf("buffer[%d] %d \n",k, buffer[k]);}
	return 0;
}
