/* massage chair controlled by tiny84 via USB designed by takefuji
*/
#include <usb.h>
#include <stdio.h>
#include <string.h>
unsigned short IDVendor=   0x1384;		/*VID must be changed. */
unsigned short IDProduct=  0x8888;		/*PID must be changed. */

static int usbOpenDevice(usb_dev_handle **device, int idvendor, int idproduct)
{
	struct usb_bus *bus;
	struct usb_device *dev;
	usb_dev_handle *udh=NULL;
	int ret,retp, retm,errors;
	char string[256];

	usb_init();
	usb_find_busses();
	ret=usb_find_devices(); if(ret==0){return errors=1;}
for (bus = usb_busses; bus; bus = bus->next)
	{
		for (dev = bus->devices; dev; dev = dev->next)
		{
			udh=usb_open(dev);
			retp = usb_get_string_simple(udh, dev->descriptor.iProduct, string, sizeof(string));
			retm=usb_get_string_simple(udh, dev->descriptor.iManufacturer, string, sizeof(string));
			if (retp > 0 && retm > 0)
				if (idvendor==dev->descriptor.idVendor && idproduct==dev->descriptor.idProduct){ *device=udh;return errors=0;}
		}
	}
				 usb_close(udh);return errors=1;
}

rotateR(int seconds)
{
	usb_dev_handle *d=NULL;
	unsigned char buffer[16];
	unsigned char i=0,j=1,k=2,l=3,m=4,n=5,o=6,p=0,q,th,ret,lp;

  ret=usbOpenDevice(&d, IDVendor,IDProduct);
if(ret!=0){printf("usbOpenDevice failed\n"); return 0;}
j=0x40;
printf("rotateR %d seconds\n",seconds);
for(lp=0;lp<seconds;lp++) {
	ret=usb_control_msg(d, USB_TYPE_VENDOR | USB_RECIP_DEVICE | USB_ENDPOINT_IN,   i,(0xff & j)|(0xff00 & (256*k)), (0x0ff & l)|(0xff00 & (256*m)),(char *)buffer,(0xff & n)| (0xff00 & (256*o)),5000);
sleep(1); }
}

rotateL(int seconds)
{
	usb_dev_handle *d=NULL;
	unsigned char buffer[16];
	unsigned char i=0,j=1,k=2,l=3,m=4,n=5,o=6,p=0,q,th,ret,lp;

  ret=usbOpenDevice(&d, IDVendor,IDProduct);
if(ret!=0){printf("usbOpenDevice failed\n"); return 0;}
j=0x20;
printf("rotateL %d seconds\n",seconds);
for(lp=0;lp<seconds;lp++) {
	ret=usb_control_msg(d, USB_TYPE_VENDOR | USB_RECIP_DEVICE | USB_ENDPOINT_IN,   i,(0xff & j)|(0xff00 & (256*k)), (0x0ff & l)|(0xff00 & (256*m)),(char *)buffer,(0xff & n)| (0xff00 & (256*o)),5000);
sleep(1); }
}

stop() {
	usb_dev_handle *d=NULL;
	unsigned char buffer[16];
	unsigned char i=0,j=1,k=2,l=3,m=4,n=5,o=6,p=0,q,th,ret,lp;

ret=usbOpenDevice(&d, IDVendor,IDProduct);
if(ret!=0){printf("usbOpenDevice failed\n"); return 0;}
j=0x00;
printf("stop\n");
	ret=usb_control_msg(d, USB_TYPE_VENDOR | USB_RECIP_DEVICE | USB_ENDPOINT_IN,   i,(0xff & j)|(0xff00 & (256*k)), (0x0ff & l)|(0xff00 & (256*m)),(char *)buffer,(0xff & n)| (0xff00 & (256*o)),5000);
}

upward(int msec)
{
	usb_dev_handle *d=NULL;
	unsigned char buffer[16];
	unsigned char i=0,j=1,k=2,l=3,m=4,n=5,o=6,p=0,q,th,ret,lp;

ret=usbOpenDevice(&d, IDVendor,IDProduct);
if(ret!=0){printf("usbOpenDevice failed\n"); return 0;}
j=0x10;
printf("upward %d msec\n",msec);
for(lp=0;lp<msec;lp++){
	ret=usb_control_msg(d, USB_TYPE_VENDOR | USB_RECIP_DEVICE | USB_ENDPOINT_IN,   i,(0xff & j)|(0xff00 & (256*k)), (0x0ff & l)|(0xff00 & (256*m)),(char *)buffer,(0xff & n)| (0xff00 & (256*o)),5000);

if((buffer[1] & 0x80)!=0){ j=0x00;
	ret=usb_control_msg(d, USB_TYPE_VENDOR | USB_RECIP_DEVICE | USB_ENDPOINT_IN,   i,(0xff & j)|(0xff00 & (256*k)), (0x0ff & l)|(0xff00 & (256*m)),(char *)buffer,(0xff & n)| (0xff00 & (256*o)),5000);
printf("reach top\n");} 
usleep(100000); }
}

downward(int msec)
{
	usb_dev_handle *d=NULL;
	unsigned char buffer[16];
	unsigned char i=0,j=1,k=2,l=3,m=4,n=5,o=6,p=0,q,th,ret,lp;

ret=usbOpenDevice(&d, IDVendor,IDProduct);
if(ret!=0){printf("usbOpenDevice failed\n"); return 0;}
j=0x08;
printf("downward %d msec\n",msec);
for(lp=0;lp<msec;lp++){
	ret=usb_control_msg(d, USB_TYPE_VENDOR | USB_RECIP_DEVICE | USB_ENDPOINT_IN,   i,(0xff & j)|(0xff00 & (256*k)), (0x0ff & l)|(0xff00 & (256*m)),(char *)buffer,(0xff & n)| (0xff00 & (256*o)),5000);

if((buffer[0] & 0x02)!=0){ j=0x00;
	ret=usb_control_msg(d, USB_TYPE_VENDOR | USB_RECIP_DEVICE | USB_ENDPOINT_IN,   i,(0xff & j)|(0xff00 & (256*k)), (0x0ff & l)|(0xff00 & (256*m)),(char *)buffer,(0xff & n)| (0xff00 & (256*o)),5000);
printf("reach bottom\n");} 
usleep(100000); }
}

int main(int argc, char **argv)
{
	usb_dev_handle *d=NULL;
	unsigned char buffer[16];
	unsigned char i=0,j=1,k=2,l=3,m=4,n=5,o=6,p=0,q,th,ret,lp;
	int sum=0;
	char string[256];
//if(argc<2){printf("need a parameter\n"); return 0;}
//j=atoi(argv[1]);
usb_init();

//1 7 6  5  4  3  2   1  0
//S N rR rL up dn act +  -
//0 0 1  0  0  0  0  rotateR ( 0x40)
//0 0 0  1  0  0  0  rotateL ( 0x20)
//0 0 0  0  1  0  0  up      ( 0x10)
//0 0 0  0  0  1  0  down    ( 0x08)

rotateR(10);
stop();
rotateL(10);
stop();
upward(100);
stop();
downward(100);
stop();

}
